package abc.ar.visit;

import polyglot.ast.Node;
import polyglot.frontend.Job;
import polyglot.types.SemanticException;
import polyglot.types.TypeSystem;
import polyglot.visit.ContextVisitor;
import abc.ar.AbcExtension;
import abc.ar.ast.ARNodeFactory;
import abc.ar.ast.AspectRefinementDecl;
import abc.ar.ast.RefinableAspectDecl;

/**
 * 
 * @author Christian Kaestner and Sven Apel
 * 
 * collects all aspects and refinements and stores them to the refinement list
 * 
 */
public class RefinementCollectorVisitor extends ContextVisitor {

	public RefinementCollectorVisitor(Job job, TypeSystem ts, ARNodeFactory nf) {
		super(job, ts, nf);
	}

	protected Node leaveCall(Node n) throws SemanticException {
		if (n instanceof AspectRefinementDecl) {
			AbcExtension.v().getRefinementManager().addRefinementDecl((AspectRefinementDecl)n);
		} else
			if (n instanceof RefinableAspectDecl) {
				AbcExtension.v().getRefinementManager().addAspectDecl((RefinableAspectDecl)n);
			} 

		return super.leaveCall(n);
	}

}
